/*----------------------------------------------------------------------*/
/*		sort.cpp		test sort										*/
/*																		*/
/*		Jeff Reid		07SEP15  14:00									*/
/*----------------------------------------------------------------------*/
/*		abbreviations for name prefixes 								*/
/*																		*/
/*		a		array of ...											*/
/*		b		unsigned char (byte)									*/
/*		cb		count of bytes in ...									*/
/*		fp		FILE pointer											*/
/*		p		pointer to ...											*/
/*		dw		unsigned int (dword)									*/
/*----------------------------------------------------------------------*/

/*		get rid of warnings for fopen */
#define _CRT_SECURE_NO_WARNINGS

#include <algorithm>
#include <fstream>
#include <iomanip>
#include <iostream>
#include <vector>

#include <stdlib.h>
#include <time.h>

#define NUMREC (1024*4096)				// number of records

typedef unsigned __int64	UI64;
typedef unsigned __int64 *	PUI64;

#define CMPFUNC 0						// set to 1 to show # compares

static clock_t dwTimeStart;				// clock values
static clock_t dwTimeStop;

static PUI64	pSort;					// ptr to sorted data
static FILE *	fpDst;					// file desc dest file

#if CMPFUNC

static UI64		qwCmp;

static bool ElemCmp(UI64 elem0, UI64 elem1)
{
	qwCmp += 1;
	return elem0 <= elem1;
}

#endif

int main( )
{
using namespace std;

	vector <UI64> vData (NUMREC);
	vector <UI64>::iterator viData;
	UI64 i;

//		generate data

	for(viData = vData.begin(); viData != vData.end(); viData++ )
    {
		i  = (((UI64)((rand()>>4) & 0xff))<< 0);
		i += (((UI64)((rand()>>4) & 0xff))<< 8);
		i += (((UI64)((rand()>>4) & 0xff))<<16);
		i += (((UI64)((rand()>>4) & 0xff))<<24);
		i += (((UI64)((rand()>>4) & 0xff))<<32);
		i += (((UI64)((rand()>>4) & 0xff))<<40);
		i += (((UI64)((rand()>>4) & 0xff))<<48);
		i += (((UI64)((rand()>>4) & 0xff))<<56);
		*viData = i ;
	}

//		sort data

	dwTimeStart = clock();

#if CMPFUNC
	stable_sort(vData.begin( ), vData.end( ), ElemCmp);
#else
	stable_sort(vData.begin( ), vData.end( ));
#endif

	dwTimeStop = clock();
	cout << "Number of ticks " << (dwTimeStop-dwTimeStart) << "\n";

#if CMPFUNC
	printf("# of compares %10ld\n", qwCmp);
#endif

//		output data

	pSort = &vData[0];
	fpDst = fopen("dsts.bin", "wb");
	if(fpDst == NULL){
		goto exit0;}
	fwrite(pSort, 1, NUMREC*sizeof(UI64), fpDst);
	fclose(fpDst);

exit0:
	return(0);
}
